#!/bin/bash

# Copyright (c) 2007 Chuck Houpt. All rights reserved.

set -eux



# Setup reasonable defaults when running outside XCode.
BUILD_DIR=${BUILD_DIR:-$PWD/build}
PROJECT_DIR=${PROJECT_DIR:-$PWD}
#SDKROOT_ppc=${SDKROOT_ppc:-/Developer/SDKs/MacOSX10.3.9.sdk}
#SDKROOT_ppc=${SDKROOT_ppc:-/Developer/SDKs/MacOSX10.4u.sdk}
#SDKROOT_i386=${SDKROOT_i386:-/Developer/SDKs/MacOSX10.4u.sdk}
#SDKROOT=/Developer/SDKs/MacOSX10.4u.sdk

# Set up reasonable default when running outside mutibuild.sh
#ARCH=${ARCH:-`arch`}
export MULTIBUILD_NCPU=${MULTIBUILD_NCPU:-`sysctl -n hw.ncpu`}

SOURCE_CACHE="$HOME/Library/Caches/net.habilis.source"

#SRC_DIR="$BUILD_DIR"/$ARCH/perlmods
SRC_DIR="$BUILD_DIR"/perlmods
PREFIX="$BUILD_DIR"/root
#EXEC_PREFIX="$PREFIX"/$ARCH
EXEC_PREFIX="$PREFIX"
#eval SDKROOT=\$SDKROOT_$ARCH

if [ ! -r "$PREFIX"/lib/perl5/local/lib.pm ]
then
	pushd local-lib-1.008004
	perl5.10 Makefile.PL --bootstrap="$PREFIX"
	make test install
	popd
fi

eval $(perl5.10 -I"$PREFIX"/lib/perl5/ -Mlocal::lib="$PREFIX")

#export CPPFLAGS=-I"$PREFIX"/include

export DYLD_LIBRARY_PATH="$EXEC_PREFIX"/lib
#perl5.10 -MCPAN -e "install SGML::Parser::OpenSP" INC="-I$PREFIX/include"
#exit
cpan5.10 -i "Bundle::W3C::Validator"

exit

#export CFLAGS="-arch $ARCH -Os -isysroot $SDKROOT"
#export LDFLAGS="-arch $ARCH -Wl,-syslibroot,$SDKROOT"
#export CC="gcc -arch ppc -arch i386"
#export CFLAGS="-arch ppc -arch i386 -Os -isysroot $SDKROOT"
#export LDFLAGS="-arch ppc -arch i386 -Wl,-syslibroot,$SDKROOT"
CFLAGS=
LDFLAGS=

# Add installed binaries to PATH
PATH="$EXEC_PREFIX"/bin:"$EXEC_PREFIX"/usr/bin:$PATH
export DYLD_LIBRARY_PATH="$EXEC_PREFIX"/lib

function buildmodule ()
{
    local module_url="$1"
	local module=`basename $module_url`

	if [ ! -r "$SOURCE_CACHE"/${module}.tar.gz ]
	then
		mkdir -p "$SOURCE_CACHE"
		pushd "$SOURCE_CACHE"
		curl -fsO http://www.cpan.org/modules/by-module/${module_url}.tar.gz
		popd
	fi
    
	if [ ! -d ${module} ]
	then
#	rm -rf ${module}
    tar xzf "$SOURCE_CACHE"/${module}.tar.gz
	fi
	
    pushd ${module}
    # Workaround for broken LD setting in SGML::Parser::OpenSP
    #export MACOSX_DEPLOYMENT_TARGET=10.3
#    export PERLLIB="$INSTALL_DIR"/lib:"$INSTALL_DIR"/lib/darwin-thread-multi-2level

#INSTALLSITEARCH="$EXEC_PREFIX"/lib
	if [ ! -f Makefile ]
	then
	# For 10.5, changed -I/System/Library/Perl/5.8.6/Encode to 5.8.8
		perl Makefile.PL PREFIX="$PREFIX" LIB="$PREFIX"/lib INSTALLARCHLIB="$EXEC_PREFIX"/lib INSTALLSITEARCH="$EXEC_PREFIX"/lib INSTALLVENDORARCH="$EXEC_PREFIX"/lib INC="-I$PREFIX/include" CCFLAGS="$CFLAGS" LDDLFLAGS="-bundle -undefined dynamic_lookup -L$EXEC_PREFIX/lib -losp $LDFLAGS"
	fi
# LDDLFLAGS="-L$BUILD_DIR/opensp/lib"

	# Skip tests when cross-compiling
    #if [ `arch` == $ARCH ]

	# HanExtra tries to call enc2xs -C to make HanExtra auto-load with
	# the rest of Encode, so avoid the install target.
	if [ ${module} == 'Encode-HanExtra-0.10' ]
	then
		make test all pure_install doc_install
	else
		make test install
	fi
    popd
}

# Not strictly correct, just checking for any build result.
if [ -f "$PREFIX"/lib/auto/HTML/Parser/Parser.bundle ] ; then exit ; fi

mkdir -p "$SRC_DIR"

#export PERLLIB="$PREFIX"/lib:"$PREFIX"/lib/darwin-thread-multi-2level
export PERL5LIB="$PREFIX"/lib:"$EXEC_PREFIX"/lib
# Force default answers to MakeMaker prompts
export PERL_MM_USE_DEFAULT=1

pushd "$SRC_DIR"

# needed for SSI, if only it would work:  Date/Date-Format? HTML/HTML-SimpleParse-0.12 CGI/CGI-SSI-0.91 CGI/CGI-SSI_Parser-0.01

# For 10.5, removed Test/Test-Builder-Tester-1.01 because 10.5 has a newer version
# for 10.7 removed: XML/XML-NamespaceSupport-1.09 XML/XML-LibXML-Common-0.13 XML/XML-SAX-0.16   XML/XML-LibXML-1.63 
for modurl in    Encode/Encode-HanExtra-0.10 Encode/Encode-JIS2K-0.02 URI/URI-1.35 Net/Net-IP-1.24 Text/Text-Iconv-1.4 Config/Config-General-2.31 Set/Set-IntSpan-1.13 HTML/HTML-Tagset-3.10 HTML/libwww-perl-5.805 HTML/HTML-Template-2.8 HTML/HTML-Parser-3.56 HTML/HTML-Encoding-0.53 Class/Class-Accessor-0.30 Sub/Sub-Uplevel-0.13  Test/Test-Exception-0.25 SGML/SGML-Parser-OpenSP-0.994
do
  buildmodule ${modurl}
done

popd

# Add the pre-made OpenSP libraries from 10.4's perl 5.8.6 build
# TODO: find a way to build back-compatible perl modules!
#cp -f "$PROJECT_DIR"/OpenSP.bundle "$EXEC_PREFIX"/lib/auto/SGML/Parser/OpenSP
